#ifndef __CELLSTATE_H__
#define __CELLSTATE_H__

class CellState
{
 private:
  string name;
  int color;
  CellTransitionList *transitions;
  EmissionList *emissions;

 public:
  CellState (string p_name, CellTransitionList *p_transitions, EmissionList *p_emissions, int color);
  ~CellState (); 

  string toString () const ;
  string getName () const ;
  void resolveStates (CellProgram *) ;
  void resolveChemicals (CellProgram *) ;
  void getTransition (Environment *env, CellStateId *next1, CellStateId *next2, t_splitKind *mode) ;
  EmissionList *getEmissions () const ;
  bool hasColor () const;
  int getColor () const;
};

# endif
