/*
** mailbox.cc
*/

# include "basic.h"

struct ListNode {
		void *data; int sz;
		ListNode *left,*right;
};

MailBox::MailBox()
{
	head=tail=NULL;
}

void MailBox::send(void *data, int sz)
{
	ListNode* tmp;
	//printf("mailbox::send(%x,%d)\n",data,sz);
	tmp=new ListNode;
	tmp->data=malloc(sz);   /* Note: important to make a copy of the data */
	memcpy(tmp->data,data,sz);
	tmp->sz=sz;
	if (head) head->left=tmp;
	tmp->left=NULL;
	tmp->right=head;
	if (!head) tail=tmp;
	head=tmp;
}

/* assumes that you are taking out something, whose size you know */
int MailBox::recv(void *data, int expectedsz)
{
	ListNode *tmp;
	int sz;
	if (!tail) return -1;
	sz =  tail->sz;
	if (sz!=expectedsz) {
		fprintf(stderr,"Warning: size mismatch in MailBox::recv()\n");
		return -2;
	}
	memcpy(data,tail->data,sz);
	free (tail->data);
	tmp=tail;
	tail=tail->left;
	if (!tail) 	
		head=NULL;
	else {
		tail->right=NULL;
	}
	free (tmp);
	//printf("mailbox::recv(%d) returns %x\n",*sz,data);
	return sz;
}

